"""autogenerated by genmsg_py from ArticulatedObjectSrvRequest.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime
import articulation_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import visualization_msgs.msg
import std_msgs.msg

class ArticulatedObjectSrvRequest(roslib.message.Message):
  _md5sum = "929d83624d0744de900991740e4bff8e"
  _type = "articulation_msgs/ArticulatedObjectSrvRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """








articulation_msgs/ArticulatedObjectMsg object


================================================================================
MSG: articulation_msgs/ArticulatedObjectMsg
Header header

articulation_msgs/TrackMsg[] parts    # observed trajectories for each object part 
articulation_msgs/ParamMsg[] params   # global parameters
articulation_msgs/ModelMsg[] models	  # models, describing relationships between parts
visualization_msgs/MarkerArray markers # marker visualization of models/object 
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: articulation_msgs/TrackMsg
# Single kinematic trajectory
#
# This message contains a kinematic trajectory. The trajectory is specified
# as a vector of 6D poses. An additional flag, track_type, indicates whether
# the track is valid, and whether it includes orientation. The track id
# can be used for automatic coloring in the RVIZ track plugin, and can be 
# freely chosen by the client. 
#
# A model is fitting only from the trajectory stored in the pose[]-vector. 
# Additional information may be associated to each pose using the channels
# vector, with arbitrary # fields (e.g., to include applied/measured forces). 
#
# After model evaluation,
# also the associated configurations of the object are stored in the channels,
# named "q[0]".."q[DOF-1]", where DOF is the number of degrees of freedom.
# Model evaluation also projects the poses in the pose vector onto the model,
# and stores these ideal poses in the vector pose_projected. Further, during model
# evaluation, a new set of (uniform) configurations over the valid configuration
# range is sampled, and the result is stored in pose_resampled.
# The vector pose_flags contains additional display flags for the poses in the
# pose vector, for example, whether a pose is visible and/or
# the end of a trajectory segment. At the moment, this is only used by the
# prior_model_learner.
#

Header header                           # Timestamp and frame
int32 id                                # used-specified track id

geometry_msgs/Pose[] pose               # sequence of poses, defining the observed trajectory
geometry_msgs/Pose[] pose_projected     # sequence of poses, projected to the model 
                                        # (after model evaluation)
geometry_msgs/Pose[] pose_resampled     # sequence of poses, re-sampled from the model in
                                        # the valid configuration range
uint32[] pose_flags                     # bit-wise combination of POSE_VISIBLE and POSE_END_OF_SEGMENT

uint32 POSE_VISIBLE=1
uint32 POSE_END_OF_SEGMENT=2

# Each channel should have the same number of elements as pose array, 
# and the data in each channel should correspond 1:1 with each pose
# possible channels: "width", "height", "rgb", ...
sensor_msgs/ChannelFloat32[] channels       



================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   "u", "v" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   "rgb" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   "intensity" - laser or pixel intensity.
#   "distance"

# The channel name should give semantics of the channel (e.g.
# "intensity" instead of "value").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: articulation_msgs/ParamMsg
# Single parameter passed to or from model fitting
#
# This mechanism allows to flexibly pass parameters to 
# model fitting (and vice versa). Note that these parameters 
# are model-specific: A client may supply additional
# parameters to the model estimator, and, similarly, a estimator
# may add the estimated model parameters to the model message.
# When the model is then evaluated, for example to make predictions
# or to compute the likelihood, the model class can then use
# these parameters.
#
# A parameter has a name, a value, and a type. The type globally
# indicates whether it is a prior parameter (prior to model fitting),
# or a model parameter (found during model fitting, using a maximum-
# likelihood estimator), or a cached evaluation (e.g., the likelihood
# or the BIC are a typical "side"-product of model estimation, and
# can therefore already be cached).
#
# For a list of currently used parameters, see the documentation at
# http://www.ros.org/wiki/articulation_models
#

uint8 PRIOR=0   # indicates a prior model parameter 
                # (e.g., "sigma_position")
uint8 PARAM=1   # indicates a estimated model parameter 
                # (e.g., "rot_radius", the estimated radius)
uint8 EVAL=2    # indicates a cached evaluation of the model, given 
                # the current trajectory
                # (e.g., "loglikelihood", the log likelihood of the
                # data, given the model and its parameters)

string name     # name of the parameter
float64 value   # value of the parameter
uint8 type      # type of the parameter (PRIOR, PARAM, EVAL)


================================================================================
MSG: articulation_msgs/ModelMsg
# Single kinematic model
#
# A kinematic model is defined by its model class name, and a set of parameters. 
# The client may additionally specify a model id, that can be used to colorize the
# model when visualized using the RVIZ model display.
# 
# For a list of currently implemented models, see the documetation at
# http://www.ros.org/wiki/articulation_models
#
#

Header header                        # frame and timestamp

int32 id                             # user specified model id
string name                          # name of the model family (e.g. "rotational",
                                     # "prismatic", "pca-gp", "rigid")
articulation_msgs/ParamMsg[] params  # model parameters
articulation_msgs/TrackMsg track     # trajectory from which the model is estimated, or
                                     # that is evaluated using the model

================================================================================
MSG: visualization_msgs/MarkerArray
Marker[] markers

================================================================================
MSG: visualization_msgs/Marker
# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

byte ARROW=0
byte CUBE=1
byte SPHERE=2
byte CYLINDER=3
byte LINE_STRIP=4
byte LINE_LIST=5
byte CUBE_LIST=6
byte SPHERE_LIST=7
byte POINTS=8
byte TEXT_VIEW_FACING=9
byte MESH_RESOURCE=10
byte TRIANGLE_LIST=11

byte ADD=0
byte MODIFY=0
byte DELETE=2

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"""
  __slots__ = ['object']
  _slot_types = ['articulation_msgs/ArticulatedObjectMsg']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       object
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(ArticulatedObjectSrvRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
    else:
      self.object = articulation_msgs.msg.ArticulatedObjectMsg()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object.parts)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.parts:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose:
          _v3 = val2.position
          _x = _v3
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v4 = val2.orientation
          _x = _v4
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_projected)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_projected:
          _v5 = val2.position
          _x = _v5
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v6 = val2.orientation
          _x = _v6
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_resampled:
          _v7 = val2.position
          _x = _v7
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v8 = val2.orientation
          _x = _v8
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *val1.pose_flags))
        length = len(val1.channels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.channels:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val2.values))
      length = len(self.object.params)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.params:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_dB.pack(_x.value, _x.type))
      length = len(self.object.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.models:
        _v9 = val1.header
        buff.write(_struct_I.pack(_v9.seq))
        _v10 = _v9.stamp
        _x = _v10
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v9.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.params)
        buff.write(_struct_I.pack(length))
        for val2 in val1.params:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_dB.pack(_x.value, _x.type))
        _v11 = val1.track
        _v12 = _v11.header
        buff.write(_struct_I.pack(_v12.seq))
        _v13 = _v12.stamp
        _x = _v13
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v12.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(_v11.id))
        length = len(_v11.pose)
        buff.write(_struct_I.pack(length))
        for val3 in _v11.pose:
          _v14 = val3.position
          _x = _v14
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v15 = val3.orientation
          _x = _v15
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v11.pose_projected)
        buff.write(_struct_I.pack(length))
        for val3 in _v11.pose_projected:
          _v16 = val3.position
          _x = _v16
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v17 = val3.orientation
          _x = _v17
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v11.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val3 in _v11.pose_resampled:
          _v18 = val3.position
          _x = _v18
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v19 = val3.orientation
          _x = _v19
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v11.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *_v11.pose_flags))
        length = len(_v11.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v11.channels:
          _x = val3.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val3.values))
      length = len(self.object.markers.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.markers.markers:
        _v20 = val1.header
        buff.write(_struct_I.pack(_v20.seq))
        _v21 = _v20.stamp
        _x = _v21
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v20.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v22 = val1.pose
        _v23 = _v22.position
        _x = _v23
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v24 = _v22.orientation
        _x = _v24
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v25 = val1.scale
        _x = _v25
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v26 = val1.color
        _x = _v26
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v27 = val1.lifetime
        _x = _v27
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.parts = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.TrackMsg()
        _v28 = val1.header
        start = end
        end += 4
        (_v28.seq,) = _struct_I.unpack(str[start:end])
        _v29 = _v28.stamp
        _x = _v29
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v28.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v30 = val2.position
          _x = _v30
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v31 = val2.orientation
          _x = _v31
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_projected = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v32 = val2.position
          _x = _v32
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v33 = val2.orientation
          _x = _v33
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_projected.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_resampled = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v34 = val2.position
          _x = _v34
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v35 = val2.orientation
          _x = _v35
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_resampled.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.pose_flags = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.channels = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val2.values = struct.unpack(pattern, str[start:end])
          val1.channels.append(val2)
        self.object.parts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.params = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ParamMsg()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
        self.object.params.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.models = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ModelMsg()
        _v36 = val1.header
        start = end
        end += 4
        (_v36.seq,) = _struct_I.unpack(str[start:end])
        _v37 = _v36.stamp
        _x = _v37
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v36.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.params = []
        for i in xrange(0, length):
          val2 = articulation_msgs.msg.ParamMsg()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          _x = val2
          start = end
          end += 9
          (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
          val1.params.append(val2)
        _v38 = val1.track
        _v39 = _v38.header
        start = end
        end += 4
        (_v39.seq,) = _struct_I.unpack(str[start:end])
        _v40 = _v39.stamp
        _x = _v40
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v39.frame_id = str[start:end]
        start = end
        end += 4
        (_v38.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v38.pose = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v41 = val3.position
          _x = _v41
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v42 = val3.orientation
          _x = _v42
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v38.pose.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v38.pose_projected = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v43 = val3.position
          _x = _v43
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v44 = val3.orientation
          _x = _v44
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v38.pose_projected.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v38.pose_resampled = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v45 = val3.position
          _x = _v45
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v46 = val3.orientation
          _x = _v46
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v38.pose_resampled.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        _v38.pose_flags = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v38.channels = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = struct.unpack(pattern, str[start:end])
          _v38.channels.append(val3)
        self.object.models.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.markers.markers = []
      for i in xrange(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v47 = val1.header
        start = end
        end += 4
        (_v47.seq,) = _struct_I.unpack(str[start:end])
        _v48 = _v47.stamp
        _x = _v48
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v47.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v49 = val1.pose
        _v50 = _v49.position
        _x = _v50
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v51 = _v49.orientation
        _x = _v51
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v52 = val1.scale
        _x = _v52
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v53 = val1.color
        _x = _v53
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v54 = val1.lifetime
        _x = _v54
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in xrange(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.object.markers.markers.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object.parts)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.parts:
        _v55 = val1.header
        buff.write(_struct_I.pack(_v55.seq))
        _v56 = _v55.stamp
        _x = _v56
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v55.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose:
          _v57 = val2.position
          _x = _v57
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v58 = val2.orientation
          _x = _v58
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_projected)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_projected:
          _v59 = val2.position
          _x = _v59
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v60 = val2.orientation
          _x = _v60
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_resampled:
          _v61 = val2.position
          _x = _v61
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v62 = val2.orientation
          _x = _v62
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.pose_flags.tostring())
        length = len(val1.channels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.channels:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val2.values.tostring())
      length = len(self.object.params)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.params:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_dB.pack(_x.value, _x.type))
      length = len(self.object.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.models:
        _v63 = val1.header
        buff.write(_struct_I.pack(_v63.seq))
        _v64 = _v63.stamp
        _x = _v64
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v63.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.params)
        buff.write(_struct_I.pack(length))
        for val2 in val1.params:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_dB.pack(_x.value, _x.type))
        _v65 = val1.track
        _v66 = _v65.header
        buff.write(_struct_I.pack(_v66.seq))
        _v67 = _v66.stamp
        _x = _v67
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v66.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(_v65.id))
        length = len(_v65.pose)
        buff.write(_struct_I.pack(length))
        for val3 in _v65.pose:
          _v68 = val3.position
          _x = _v68
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v69 = val3.orientation
          _x = _v69
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v65.pose_projected)
        buff.write(_struct_I.pack(length))
        for val3 in _v65.pose_projected:
          _v70 = val3.position
          _x = _v70
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v71 = val3.orientation
          _x = _v71
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v65.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val3 in _v65.pose_resampled:
          _v72 = val3.position
          _x = _v72
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v73 = val3.orientation
          _x = _v73
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v65.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(_v65.pose_flags.tostring())
        length = len(_v65.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v65.channels:
          _x = val3.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val3.values.tostring())
      length = len(self.object.markers.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.markers.markers:
        _v74 = val1.header
        buff.write(_struct_I.pack(_v74.seq))
        _v75 = _v74.stamp
        _x = _v75
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v74.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v76 = val1.pose
        _v77 = _v76.position
        _x = _v77
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v78 = _v76.orientation
        _x = _v78
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v79 = val1.scale
        _x = _v79
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v80 = val1.color
        _x = _v80
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v81 = val1.lifetime
        _x = _v81
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.parts = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.TrackMsg()
        _v82 = val1.header
        start = end
        end += 4
        (_v82.seq,) = _struct_I.unpack(str[start:end])
        _v83 = _v82.stamp
        _x = _v83
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v82.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v84 = val2.position
          _x = _v84
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v85 = val2.orientation
          _x = _v85
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_projected = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v86 = val2.position
          _x = _v86
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v87 = val2.orientation
          _x = _v87
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_projected.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_resampled = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v88 = val2.position
          _x = _v88
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v89 = val2.orientation
          _x = _v89
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_resampled.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.pose_flags = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.channels = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val2.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          val1.channels.append(val2)
        self.object.parts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.params = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ParamMsg()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
        self.object.params.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.models = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ModelMsg()
        _v90 = val1.header
        start = end
        end += 4
        (_v90.seq,) = _struct_I.unpack(str[start:end])
        _v91 = _v90.stamp
        _x = _v91
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v90.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.params = []
        for i in xrange(0, length):
          val2 = articulation_msgs.msg.ParamMsg()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          _x = val2
          start = end
          end += 9
          (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
          val1.params.append(val2)
        _v92 = val1.track
        _v93 = _v92.header
        start = end
        end += 4
        (_v93.seq,) = _struct_I.unpack(str[start:end])
        _v94 = _v93.stamp
        _x = _v94
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v93.frame_id = str[start:end]
        start = end
        end += 4
        (_v92.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v92.pose = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v95 = val3.position
          _x = _v95
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v96 = val3.orientation
          _x = _v96
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v92.pose.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v92.pose_projected = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v97 = val3.position
          _x = _v97
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v98 = val3.orientation
          _x = _v98
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v92.pose_projected.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v92.pose_resampled = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v99 = val3.position
          _x = _v99
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v100 = val3.orientation
          _x = _v100
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v92.pose_resampled.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        _v92.pose_flags = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v92.channels = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          _v92.channels.append(val3)
        self.object.models.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.markers.markers = []
      for i in xrange(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v101 = val1.header
        start = end
        end += 4
        (_v101.seq,) = _struct_I.unpack(str[start:end])
        _v102 = _v101.stamp
        _x = _v102
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v101.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v103 = val1.pose
        _v104 = _v103.position
        _x = _v104
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v105 = _v103.orientation
        _x = _v105
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v106 = val1.scale
        _x = _v106
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v107 = val1.color
        _x = _v107
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v108 = val1.lifetime
        _x = _v108
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in xrange(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.object.markers.markers.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
_struct_dB = struct.Struct("<dB")
_struct_3i = struct.Struct("<3i")
_struct_2i = struct.Struct("<2i")
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_4f = struct.Struct("<4f")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
"""autogenerated by genmsg_py from ArticulatedObjectSrvResponse.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime
import articulation_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import visualization_msgs.msg
import std_msgs.msg

class ArticulatedObjectSrvResponse(roslib.message.Message):
  _md5sum = "929d83624d0744de900991740e4bff8e"
  _type = "articulation_msgs/ArticulatedObjectSrvResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """articulation_msgs/ArticulatedObjectMsg object






================================================================================
MSG: articulation_msgs/ArticulatedObjectMsg
Header header

articulation_msgs/TrackMsg[] parts    # observed trajectories for each object part 
articulation_msgs/ParamMsg[] params   # global parameters
articulation_msgs/ModelMsg[] models	  # models, describing relationships between parts
visualization_msgs/MarkerArray markers # marker visualization of models/object 
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: articulation_msgs/TrackMsg
# Single kinematic trajectory
#
# This message contains a kinematic trajectory. The trajectory is specified
# as a vector of 6D poses. An additional flag, track_type, indicates whether
# the track is valid, and whether it includes orientation. The track id
# can be used for automatic coloring in the RVIZ track plugin, and can be 
# freely chosen by the client. 
#
# A model is fitting only from the trajectory stored in the pose[]-vector. 
# Additional information may be associated to each pose using the channels
# vector, with arbitrary # fields (e.g., to include applied/measured forces). 
#
# After model evaluation,
# also the associated configurations of the object are stored in the channels,
# named "q[0]".."q[DOF-1]", where DOF is the number of degrees of freedom.
# Model evaluation also projects the poses in the pose vector onto the model,
# and stores these ideal poses in the vector pose_projected. Further, during model
# evaluation, a new set of (uniform) configurations over the valid configuration
# range is sampled, and the result is stored in pose_resampled.
# The vector pose_flags contains additional display flags for the poses in the
# pose vector, for example, whether a pose is visible and/or
# the end of a trajectory segment. At the moment, this is only used by the
# prior_model_learner.
#

Header header                           # Timestamp and frame
int32 id                                # used-specified track id

geometry_msgs/Pose[] pose               # sequence of poses, defining the observed trajectory
geometry_msgs/Pose[] pose_projected     # sequence of poses, projected to the model 
                                        # (after model evaluation)
geometry_msgs/Pose[] pose_resampled     # sequence of poses, re-sampled from the model in
                                        # the valid configuration range
uint32[] pose_flags                     # bit-wise combination of POSE_VISIBLE and POSE_END_OF_SEGMENT

uint32 POSE_VISIBLE=1
uint32 POSE_END_OF_SEGMENT=2

# Each channel should have the same number of elements as pose array, 
# and the data in each channel should correspond 1:1 with each pose
# possible channels: "width", "height", "rgb", ...
sensor_msgs/ChannelFloat32[] channels       



================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   "u", "v" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   "rgb" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   "intensity" - laser or pixel intensity.
#   "distance"

# The channel name should give semantics of the channel (e.g.
# "intensity" instead of "value").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: articulation_msgs/ParamMsg
# Single parameter passed to or from model fitting
#
# This mechanism allows to flexibly pass parameters to 
# model fitting (and vice versa). Note that these parameters 
# are model-specific: A client may supply additional
# parameters to the model estimator, and, similarly, a estimator
# may add the estimated model parameters to the model message.
# When the model is then evaluated, for example to make predictions
# or to compute the likelihood, the model class can then use
# these parameters.
#
# A parameter has a name, a value, and a type. The type globally
# indicates whether it is a prior parameter (prior to model fitting),
# or a model parameter (found during model fitting, using a maximum-
# likelihood estimator), or a cached evaluation (e.g., the likelihood
# or the BIC are a typical "side"-product of model estimation, and
# can therefore already be cached).
#
# For a list of currently used parameters, see the documentation at
# http://www.ros.org/wiki/articulation_models
#

uint8 PRIOR=0   # indicates a prior model parameter 
                # (e.g., "sigma_position")
uint8 PARAM=1   # indicates a estimated model parameter 
                # (e.g., "rot_radius", the estimated radius)
uint8 EVAL=2    # indicates a cached evaluation of the model, given 
                # the current trajectory
                # (e.g., "loglikelihood", the log likelihood of the
                # data, given the model and its parameters)

string name     # name of the parameter
float64 value   # value of the parameter
uint8 type      # type of the parameter (PRIOR, PARAM, EVAL)


================================================================================
MSG: articulation_msgs/ModelMsg
# Single kinematic model
#
# A kinematic model is defined by its model class name, and a set of parameters. 
# The client may additionally specify a model id, that can be used to colorize the
# model when visualized using the RVIZ model display.
# 
# For a list of currently implemented models, see the documetation at
# http://www.ros.org/wiki/articulation_models
#
#

Header header                        # frame and timestamp

int32 id                             # user specified model id
string name                          # name of the model family (e.g. "rotational",
                                     # "prismatic", "pca-gp", "rigid")
articulation_msgs/ParamMsg[] params  # model parameters
articulation_msgs/TrackMsg track     # trajectory from which the model is estimated, or
                                     # that is evaluated using the model

================================================================================
MSG: visualization_msgs/MarkerArray
Marker[] markers

================================================================================
MSG: visualization_msgs/Marker
# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

byte ARROW=0
byte CUBE=1
byte SPHERE=2
byte CYLINDER=3
byte LINE_STRIP=4
byte LINE_LIST=5
byte CUBE_LIST=6
byte SPHERE_LIST=7
byte POINTS=8
byte TEXT_VIEW_FACING=9
byte MESH_RESOURCE=10
byte TRIANGLE_LIST=11

byte ADD=0
byte MODIFY=0
byte DELETE=2

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"""
  __slots__ = ['object']
  _slot_types = ['articulation_msgs/ArticulatedObjectMsg']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       object
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(ArticulatedObjectSrvResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
    else:
      self.object = articulation_msgs.msg.ArticulatedObjectMsg()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object.parts)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.parts:
        _v109 = val1.header
        buff.write(_struct_I.pack(_v109.seq))
        _v110 = _v109.stamp
        _x = _v110
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v109.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose:
          _v111 = val2.position
          _x = _v111
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v112 = val2.orientation
          _x = _v112
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_projected)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_projected:
          _v113 = val2.position
          _x = _v113
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v114 = val2.orientation
          _x = _v114
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_resampled:
          _v115 = val2.position
          _x = _v115
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v116 = val2.orientation
          _x = _v116
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *val1.pose_flags))
        length = len(val1.channels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.channels:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val2.values))
      length = len(self.object.params)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.params:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_dB.pack(_x.value, _x.type))
      length = len(self.object.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.models:
        _v117 = val1.header
        buff.write(_struct_I.pack(_v117.seq))
        _v118 = _v117.stamp
        _x = _v118
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v117.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.params)
        buff.write(_struct_I.pack(length))
        for val2 in val1.params:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_dB.pack(_x.value, _x.type))
        _v119 = val1.track
        _v120 = _v119.header
        buff.write(_struct_I.pack(_v120.seq))
        _v121 = _v120.stamp
        _x = _v121
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v120.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(_v119.id))
        length = len(_v119.pose)
        buff.write(_struct_I.pack(length))
        for val3 in _v119.pose:
          _v122 = val3.position
          _x = _v122
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v123 = val3.orientation
          _x = _v123
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v119.pose_projected)
        buff.write(_struct_I.pack(length))
        for val3 in _v119.pose_projected:
          _v124 = val3.position
          _x = _v124
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v125 = val3.orientation
          _x = _v125
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v119.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val3 in _v119.pose_resampled:
          _v126 = val3.position
          _x = _v126
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v127 = val3.orientation
          _x = _v127
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v119.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.pack(pattern, *_v119.pose_flags))
        length = len(_v119.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v119.channels:
          _x = val3.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val3.values))
      length = len(self.object.markers.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.markers.markers:
        _v128 = val1.header
        buff.write(_struct_I.pack(_v128.seq))
        _v129 = _v128.stamp
        _x = _v129
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v128.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v130 = val1.pose
        _v131 = _v130.position
        _x = _v131
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v132 = _v130.orientation
        _x = _v132
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v133 = val1.scale
        _x = _v133
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v134 = val1.color
        _x = _v134
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v135 = val1.lifetime
        _x = _v135
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.parts = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.TrackMsg()
        _v136 = val1.header
        start = end
        end += 4
        (_v136.seq,) = _struct_I.unpack(str[start:end])
        _v137 = _v136.stamp
        _x = _v137
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v136.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v138 = val2.position
          _x = _v138
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v139 = val2.orientation
          _x = _v139
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_projected = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v140 = val2.position
          _x = _v140
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v141 = val2.orientation
          _x = _v141
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_projected.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_resampled = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v142 = val2.position
          _x = _v142
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v143 = val2.orientation
          _x = _v143
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_resampled.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.pose_flags = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.channels = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val2.values = struct.unpack(pattern, str[start:end])
          val1.channels.append(val2)
        self.object.parts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.params = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ParamMsg()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
        self.object.params.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.models = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ModelMsg()
        _v144 = val1.header
        start = end
        end += 4
        (_v144.seq,) = _struct_I.unpack(str[start:end])
        _v145 = _v144.stamp
        _x = _v145
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v144.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.params = []
        for i in xrange(0, length):
          val2 = articulation_msgs.msg.ParamMsg()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          _x = val2
          start = end
          end += 9
          (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
          val1.params.append(val2)
        _v146 = val1.track
        _v147 = _v146.header
        start = end
        end += 4
        (_v147.seq,) = _struct_I.unpack(str[start:end])
        _v148 = _v147.stamp
        _x = _v148
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v147.frame_id = str[start:end]
        start = end
        end += 4
        (_v146.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v146.pose = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v149 = val3.position
          _x = _v149
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v150 = val3.orientation
          _x = _v150
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v146.pose.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v146.pose_projected = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v151 = val3.position
          _x = _v151
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v152 = val3.orientation
          _x = _v152
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v146.pose_projected.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v146.pose_resampled = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v153 = val3.position
          _x = _v153
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v154 = val3.orientation
          _x = _v154
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v146.pose_resampled.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        _v146.pose_flags = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v146.channels = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = struct.unpack(pattern, str[start:end])
          _v146.channels.append(val3)
        self.object.models.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.markers.markers = []
      for i in xrange(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v155 = val1.header
        start = end
        end += 4
        (_v155.seq,) = _struct_I.unpack(str[start:end])
        _v156 = _v155.stamp
        _x = _v156
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v155.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v157 = val1.pose
        _v158 = _v157.position
        _x = _v158
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v159 = _v157.orientation
        _x = _v159
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v160 = val1.scale
        _x = _v160
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v161 = val1.color
        _x = _v161
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v162 = val1.lifetime
        _x = _v162
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in xrange(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.object.markers.markers.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs))
      _x = self.object.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object.parts)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.parts:
        _v163 = val1.header
        buff.write(_struct_I.pack(_v163.seq))
        _v164 = _v163.stamp
        _x = _v164
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v163.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.pose)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose:
          _v165 = val2.position
          _x = _v165
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v166 = val2.orientation
          _x = _v166
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_projected)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_projected:
          _v167 = val2.position
          _x = _v167
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v168 = val2.orientation
          _x = _v168
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pose_resampled:
          _v169 = val2.position
          _x = _v169
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v170 = val2.orientation
          _x = _v170
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.pose_flags.tostring())
        length = len(val1.channels)
        buff.write(_struct_I.pack(length))
        for val2 in val1.channels:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val2.values.tostring())
      length = len(self.object.params)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.params:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_dB.pack(_x.value, _x.type))
      length = len(self.object.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.models:
        _v171 = val1.header
        buff.write(_struct_I.pack(_v171.seq))
        _v172 = _v171.stamp
        _x = _v172
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v171.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(val1.id))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.params)
        buff.write(_struct_I.pack(length))
        for val2 in val1.params:
          _x = val2.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2
          buff.write(_struct_dB.pack(_x.value, _x.type))
        _v173 = val1.track
        _v174 = _v173.header
        buff.write(_struct_I.pack(_v174.seq))
        _v175 = _v174.stamp
        _x = _v175
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v174.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_i.pack(_v173.id))
        length = len(_v173.pose)
        buff.write(_struct_I.pack(length))
        for val3 in _v173.pose:
          _v176 = val3.position
          _x = _v176
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v177 = val3.orientation
          _x = _v177
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v173.pose_projected)
        buff.write(_struct_I.pack(length))
        for val3 in _v173.pose_projected:
          _v178 = val3.position
          _x = _v178
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v179 = val3.orientation
          _x = _v179
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v173.pose_resampled)
        buff.write(_struct_I.pack(length))
        for val3 in _v173.pose_resampled:
          _v180 = val3.position
          _x = _v180
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v181 = val3.orientation
          _x = _v181
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(_v173.pose_flags)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(_v173.pose_flags.tostring())
        length = len(_v173.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v173.channels:
          _x = val3.name
          length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val3.values.tostring())
      length = len(self.object.markers.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.object.markers.markers:
        _v182 = val1.header
        buff.write(_struct_I.pack(_v182.seq))
        _v183 = _v182.stamp
        _x = _v183
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v182.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v184 = val1.pose
        _v185 = _v184.position
        _x = _v185
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v186 = _v184.orientation
        _x = _v186
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v187 = val1.scale
        _x = _v187
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v188 = val1.color
        _x = _v188
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v189 = val1.lifetime
        _x = _v189
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.object is None:
        self.object = articulation_msgs.msg.ArticulatedObjectMsg()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.object.header.seq, _x.object.header.stamp.secs, _x.object.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.object.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.parts = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.TrackMsg()
        _v190 = val1.header
        start = end
        end += 4
        (_v190.seq,) = _struct_I.unpack(str[start:end])
        _v191 = _v190.stamp
        _x = _v191
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v190.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v192 = val2.position
          _x = _v192
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v193 = val2.orientation
          _x = _v193
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_projected = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v194 = val2.position
          _x = _v194
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v195 = val2.orientation
          _x = _v195
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_projected.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pose_resampled = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          _v196 = val2.position
          _x = _v196
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v197 = val2.orientation
          _x = _v197
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          val1.pose_resampled.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        val1.pose_flags = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.channels = []
        for i in xrange(0, length):
          val2 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val2.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          val1.channels.append(val2)
        self.object.parts.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.params = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ParamMsg()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
        self.object.params.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.models = []
      for i in xrange(0, length):
        val1 = articulation_msgs.msg.ModelMsg()
        _v198 = val1.header
        start = end
        end += 4
        (_v198.seq,) = _struct_I.unpack(str[start:end])
        _v199 = _v198.stamp
        _x = _v199
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v198.frame_id = str[start:end]
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.params = []
        for i in xrange(0, length):
          val2 = articulation_msgs.msg.ParamMsg()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val2.name = str[start:end]
          _x = val2
          start = end
          end += 9
          (_x.value, _x.type,) = _struct_dB.unpack(str[start:end])
          val1.params.append(val2)
        _v200 = val1.track
        _v201 = _v200.header
        start = end
        end += 4
        (_v201.seq,) = _struct_I.unpack(str[start:end])
        _v202 = _v201.stamp
        _x = _v202
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v201.frame_id = str[start:end]
        start = end
        end += 4
        (_v200.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v200.pose = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v203 = val3.position
          _x = _v203
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v204 = val3.orientation
          _x = _v204
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v200.pose.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v200.pose_projected = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v205 = val3.position
          _x = _v205
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v206 = val3.orientation
          _x = _v206
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v200.pose_projected.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v200.pose_resampled = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Pose()
          _v207 = val3.position
          _x = _v207
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v208 = val3.orientation
          _x = _v208
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v200.pose_resampled.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        end += struct.calcsize(pattern)
        _v200.pose_flags = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v200.channels = []
        for i in xrange(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          _v200.channels.append(val3)
        self.object.models.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object.markers.markers = []
      for i in xrange(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v209 = val1.header
        start = end
        end += 4
        (_v209.seq,) = _struct_I.unpack(str[start:end])
        _v210 = _v209.stamp
        _x = _v210
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v209.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v211 = val1.pose
        _v212 = _v211.position
        _x = _v212
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v213 = _v211.orientation
        _x = _v213
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v214 = val1.scale
        _x = _v214
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v215 = val1.color
        _x = _v215
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v216 = val1.lifetime
        _x = _v216
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in xrange(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.object.markers.markers.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_B = struct.Struct("<B")
_struct_dB = struct.Struct("<dB")
_struct_3i = struct.Struct("<3i")
_struct_2i = struct.Struct("<2i")
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_4f = struct.Struct("<4f")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
class ArticulatedObjectSrv(roslib.message.ServiceDefinition):
  _type          = 'articulation_msgs/ArticulatedObjectSrv'
  _md5sum = 'd13520b58d3ca45a23cc7f92f8661f22'
  _request_class  = ArticulatedObjectSrvRequest
  _response_class = ArticulatedObjectSrvResponse
